Spectra =   require('spectra')
local lg = love.graphics
-------------------------------
function love.load()
   width,height = lg.getDimensions()
   --Test Grid to show gradient
   grid = {}
   for i=1,32 do
      grid[i] = {}
      for j=1,32 do
         grid[i][j] = {x=width/32*(i-1), y=height/32*(j-1)}
      end
   end
   --Range of color gradient
   range = width/2
   --Initialize Spectra with default palette
   spectra = Spectra()
end

function love.update(dt)
   --Update Mouse Coordinates
   mouseX,mouseY = love.mouse.getPosition()
   --Update Clamping Control
   if love.keyboard.isDown('1') then
      spectra:clamp('red',1, 'white', 1)
   elseif love.keyboard.isDown('2') then
      spectra:clamp('darkgray',1, 'white', 1)
   elseif love.keyboard.isDown('3') then
      spectra:clamp('purple',.25, 'green', .5)
   else
      spectra:clamp()
   end
end

function love.draw()
   --Iterate through test grid and color each tile
   for k,v in pairs(grid) do
      for _,coord in ipairs(v) do
         local distance = ((mouseX-coord.x)^2+(mouseY-coord.y)^2)^0.5
         lg.setColor(spectra:gradient(range, distance, {'green','yellow','orange','maroon'}))
         lg.rectangle('fill', coord.x, coord.y, width/32, height/32)
      end
   end
   --Print Instructions
   lg.setColor(spectra:get('royalblue'))
   lg.print('FPS: '..love.timer.getFPS(), 16,0)
   lg.print('Number Keys Changes Clamp Modes', 16,16)
   lg.print('Mousewheel Changes Gradient Range', 16,32)
end

function love.wheelmoved(x, y)
   --Update range
    range = range + y*16
end
